import { Service } from '@/common/domain/Service';

export type ServiceProjection =
  | 'aop-logging'
  | 'angular'
  | 'angular-with-jwt'
  | 'angular-oauth2'
  | 'angular-health'
  | 'client-common-playwright'
  | 'consul'
  | 'dev-tools'
  | 'dockerfile'
  | 'download'
  | 'ehcache-with-java-config'
  | 'ehcache-with-xml-config'
  | 'eureka-client'
  | 'initialization'
  | 'flyway'
  | 'flyway-with-users-and-authority-changelogs'
  | 'frontend-maven-plugin'
  | 'github-actions'
  | 'jacoco-check-minimal-coverage'
  | 'java-base'
  | 'java-archunit'
  | 'jib'
  | 'liquibase'
  | 'liquibase-with-users-and-authority-changelogs'
  | 'logstash'
  | 'maven-java'
  | 'codespaces-setup'
  | 'gitpod-setup'
  | 'mariadb'
  | 'mysql'
  | 'mssql'
  | 'mongodb'
  | 'mongock'
  | 'postgresql'
  | 'react-cypress'
  | 'sonar-java-backend'
  | 'sonar-java-backend-and-frontend'
  | 'spring-boot'
  | 'spring-boot-actuator'
  | 'spring-doc'
  | 'spring-boot-jwt'
  | 'spring-boot-jwt-with-basic-authentication'
  | 'springdoc-openapi-with-security-jwt'
  | 'spring-boot-oauth2'
  | 'spring-boot-oauth2-account'
  | 'spring-boot-mvc-with-tomcat'
  | 'spring-boot-mvc-with-undertow'
  | 'spring-boot-zalando-problems'
  | 'spring-boot-webflux-netty'
  | 'spring-boot-dummy-feature'
  | 'spring-boot-cucumber'
  | 'spring-boot-pulsar'
  | 'spring-boot-kafka'
  | 'spring-boot-kafka-dummy-producer-consumer'
  | 'spring-boot-kafka-akhq'
  | 'spring-boot-async'
  | 'spring-cloud'
  | 'react'
  | 'react-styled'
  | 'react-jwt'
  | 'vue'
  | 'unknown';

const SERVICES_PROJECTION: Record<Service, ServiceProjection> = {
  [Service.AOP_LOGGING]: 'aop-logging',
  [Service.ANGULAR]: 'angular',
  [Service.ANGULAR_WITH_JWT]: 'angular-with-jwt',
  [Service.ANGULAR_OAUTH2]: 'angular-oauth2',
  [Service.ANGULAR_HEALTH]: 'angular-health',
  [Service.CLIENT_COMMON_PLAYWRIGHT]: 'client-common-playwright',
  [Service.CONSUL]: 'consul',
  [Service.DEV_TOOLS]: 'dev-tools',
  [Service.DOCKERFILE]: 'dockerfile',
  [Service.DOWNLOAD]: 'download',
  [Service.EHCACHE_WITH_JAVA_CONFIG]: 'ehcache-with-java-config',
  [Service.EHCACHE_WITH_XML_CONFIG]: 'ehcache-with-xml-config',
  [Service.EUREKA_CLIENT]: 'eureka-client',
  [Service.FLYWAY]: 'flyway',
  [Service.FLYWAY_WITH_USERS_AND_AUTHORITY_CHANGELOGS]: 'flyway-with-users-and-authority-changelogs',
  [Service.FRONTEND_MAVEN_PLUGIN]: 'frontend-maven-plugin',
  [Service.GITHUB_ACTIONS]: 'github-actions',
  [Service.INITIALIZATION]: 'initialization',
  [Service.JACOCO_CHECK_MINIMAL_COVERAGE]: 'jacoco-check-minimal-coverage',
  [Service.JAVA_BASE]: 'java-base',
  [Service.JAVA_ARCHUNIT]: 'java-archunit',
  [Service.JIB]: 'jib',
  [Service.LIQUIBASE]: 'liquibase',
  [Service.LIQUIBASE_WITH_USERS_AND_AUTHORITY_CHANGELOGS]: 'liquibase-with-users-and-authority-changelogs',
  [Service.LOGSTASH]: 'logstash',
  [Service.MAVEN_JAVA]: 'maven-java',
  [Service.CODESPACES_SETUP]: 'codespaces-setup',
  [Service.GITPOD_SETUP]: 'gitpod-setup',
  [Service.MARIADB]: 'mariadb',
  [Service.MYSQL]: 'mysql',
  [Service.MSSQL]: 'mssql',
  [Service.MONGODB]: 'mongodb',
  [Service.MONGOCK]: 'mongock',
  [Service.POSTGRESQL]: 'postgresql',
  [Service.REACT_CYPRESS]: 'react-cypress',
  [Service.SONAR_JAVA_BACKEND]: 'sonar-java-backend',
  [Service.SONAR_JAVA_BACKEND_AND_FRONTEND]: 'sonar-java-backend-and-frontend',
  [Service.SPRINGBOOT]: 'spring-boot',
  [Service.SPRINGBOOT_ACTUATOR]: 'spring-boot-actuator',
  [Service.SPRING_DOC]: 'spring-doc',
  [Service.SPRINGBOOT_JWT]: 'spring-boot-jwt',
  [Service.SPRINGBOOT_JWT_WITH_BASIC_AUTHENTICATION]: 'spring-boot-jwt-with-basic-authentication',
  [Service.SPRINGDOC_OPENAPI_WITH_SECURIITY_JWT]: 'springdoc-openapi-with-security-jwt',
  [Service.SPRINGBOOT_OAUTH2]: 'spring-boot-oauth2',
  [Service.SPRINGBOOT_OAUTH2_ACCOUNT]: 'spring-boot-oauth2-account',
  [Service.SPRINGBOOT_MVC_WITH_TOMCAT]: 'spring-boot-mvc-with-tomcat',
  [Service.SPRINGBOOT_MVC_WITH_UNDERTOW]: 'spring-boot-mvc-with-undertow',
  [Service.ZALANDO_PROBLEMS]: 'spring-boot-zalando-problems',
  [Service.SPRINGBOOT_DUMMY_FEATURE]: 'spring-boot-dummy-feature',
  [Service.SPRINGBOOT_WEBFLUX_NETTY]: 'spring-boot-webflux-netty',
  [Service.SPRINGBOOT_CUCUMBER]: 'spring-boot-cucumber',
  [Service.SPRINGBOOT_PULSAR]: 'spring-boot-pulsar',
  [Service.SPRINGBOOT_KAFKA]: 'spring-boot-kafka',
  [Service.SPRINGBOOT_KAFKA_DUMMY_PRODUCER_CONSUMER]: 'spring-boot-kafka-dummy-producer-consumer',
  [Service.SPRINGBOOT_KAFKA_AKHQ]: 'spring-boot-kafka-akhq',
  [Service.SPRINGBOOT_ASYNC]: 'spring-boot-async',
  [Service.SPRING_CLOUD]: 'spring-cloud',
  [Service.REACT]: 'react',
  [Service.REACT_STYLED]: 'react-styled',
  [Service.REACT_JWT]: 'react-jwt',
  [Service.VUE]: 'vue',
  [Service.UNKNOWN]: 'unknown',
};

export const toServiceProjection = (service: Service): ServiceProjection => SERVICES_PROJECTION[service];

const SERVICES: Record<ServiceProjection, Service> = {
  'aop-logging': Service.AOP_LOGGING,
  angular: Service.ANGULAR,
  'angular-with-jwt': Service.ANGULAR_WITH_JWT,
  'angular-oauth2': Service.ANGULAR_OAUTH2,
  'angular-health': Service.ANGULAR_HEALTH,
  'client-common-playwright': Service.CLIENT_COMMON_PLAYWRIGHT,
  consul: Service.CONSUL,
  'dev-tools': Service.DEV_TOOLS,
  'ehcache-with-java-config': Service.EHCACHE_WITH_JAVA_CONFIG,
  dockerfile: Service.DOCKERFILE,
  download: Service.DOWNLOAD,
  'ehcache-with-xml-config': Service.EHCACHE_WITH_XML_CONFIG,
  'eureka-client': Service.EUREKA_CLIENT,
  flyway: Service.FLYWAY,
  'flyway-with-users-and-authority-changelogs': Service.FLYWAY_WITH_USERS_AND_AUTHORITY_CHANGELOGS,
  'frontend-maven-plugin': Service.FRONTEND_MAVEN_PLUGIN,
  'github-actions': Service.GITHUB_ACTIONS,
  initialization: Service.INITIALIZATION,
  'jacoco-check-minimal-coverage': Service.JACOCO_CHECK_MINIMAL_COVERAGE,
  'java-base': Service.JAVA_BASE,
  'java-archunit': Service.JAVA_ARCHUNIT,
  jib: Service.JIB,
  liquibase: Service.LIQUIBASE,
  'liquibase-with-users-and-authority-changelogs': Service.LIQUIBASE_WITH_USERS_AND_AUTHORITY_CHANGELOGS,
  logstash: Service.LOGSTASH,
  'maven-java': Service.MAVEN_JAVA,
  'codespaces-setup': Service.CODESPACES_SETUP,
  'gitpod-setup': Service.GITPOD_SETUP,
  mariadb: Service.MARIADB,
  mysql: Service.MYSQL,
  mssql: Service.MSSQL,
  mongodb: Service.MONGODB,
  mongock: Service.MONGOCK,
  postgresql: Service.POSTGRESQL,
  'react-cypress': Service.REACT_CYPRESS,
  'sonar-java-backend': Service.SONAR_JAVA_BACKEND,
  'sonar-java-backend-and-frontend': Service.SONAR_JAVA_BACKEND_AND_FRONTEND,
  'spring-boot': Service.SPRINGBOOT,
  'spring-boot-actuator': Service.SPRINGBOOT_ACTUATOR,
  'spring-doc': Service.SPRING_DOC,
  'spring-boot-jwt': Service.SPRINGBOOT_JWT,
  'spring-boot-jwt-with-basic-authentication': Service.SPRINGBOOT_JWT_WITH_BASIC_AUTHENTICATION,
  'springdoc-openapi-with-security-jwt': Service.SPRINGDOC_OPENAPI_WITH_SECURIITY_JWT,
  'spring-boot-oauth2': Service.SPRINGBOOT_OAUTH2,
  'spring-boot-oauth2-account': Service.SPRINGBOOT_OAUTH2_ACCOUNT,
  'spring-boot-mvc-with-tomcat': Service.SPRINGBOOT_MVC_WITH_TOMCAT,
  'spring-boot-mvc-with-undertow': Service.SPRINGBOOT_MVC_WITH_UNDERTOW,
  'spring-boot-zalando-problems': Service.ZALANDO_PROBLEMS,
  'spring-boot-dummy-feature': Service.SPRINGBOOT_DUMMY_FEATURE,
  'spring-boot-webflux-netty': Service.SPRINGBOOT_WEBFLUX_NETTY,
  'spring-boot-cucumber': Service.SPRINGBOOT_CUCUMBER,
  'spring-boot-pulsar': Service.SPRINGBOOT_PULSAR,
  'spring-boot-kafka': Service.SPRINGBOOT_KAFKA,
  'spring-boot-kafka-dummy-producer-consumer': Service.SPRINGBOOT_KAFKA_DUMMY_PRODUCER_CONSUMER,
  'spring-boot-kafka-akhq': Service.SPRINGBOOT_KAFKA_AKHQ,
  'spring-boot-async': Service.SPRINGBOOT_ASYNC,
  'spring-cloud': Service.SPRING_CLOUD,
  react: Service.REACT,
  'react-styled': Service.REACT_STYLED,
  'react-jwt': Service.REACT_JWT,
  vue: Service.VUE,
  unknown: Service.UNKNOWN,
};

export const fromServiceProjection = (serviceProjection: ServiceProjection): Service => SERVICES[serviceProjection];
